import java.util.Scanner;

public class MaartenNoFloats {
    public static void main(String[] args) {
        Scanner sc = new Scanner(System.in);
        long[][] points = new long[4][2];
        for (int i = 0; i < 4; i++) {
            points[i][0] = sc.nextLong();
            points[i][1] = sc.nextLong();
        }

        long[] sides = new long[4];
        for (int i = 0; i < 4; i++) {
            sides[i] = dist(points[i], points[(i + 1) % 4]);
        }

        boolean equalDiagonals = dist(points[0], points[2]) == dist(points[1], points[3]);

        if (allEqual(sides)) {
            System.out.println(equalDiagonals ? "square" : "rhombus");
            return;
        }

        if (sides[0] == sides[2] && sides[1] == sides[3]) {
            System.out.println(equalDiagonals ? "rectangle" : "parallelogram");
            return;
        }

        if ((sides[0] == sides[1] && sides[2] == sides[3]) || (sides[1] == sides[2] && sides[3] == sides[0])) {
            System.out.println("kite");
            return;
        }

        System.out.println(isParallel(points) || isParallel(shiftArray(points)) ? "trapezium" : "none");
    }

    public static long dist(long[] p1, long[] p2) {
        return (p2[0] - p1[0]) * (p2[0] - p1[0]) + (p2[1] - p1[1]) * (p2[1] - p1[1]);
    }

    public static boolean allEqual(long[] arr) {
        for (int i = 1; i < arr.length; i++) {
            if (arr[i] != arr[0]) {
                return false;
            }
        }
        return true;
    }

    public static boolean isParallel(long[][] points) {
        return (points[0][0] - points[1][0]) * (points[3][1] - points[2][1]) == (points[3][0] - points[2][0]) * (points[0][1] - points[1][1]);
    }

    public static long[][] shiftArray(long[][] arr) {
        long[][] shiftedArr = new long[arr.length][arr[0].length];
        for (int i = 0; i < arr.length; i++) {
            shiftedArr[i] = arr[(i + 1) % arr.length];
        }
        return shiftedArr;
    }
}