import java.io.*;
import java.util.*;

public class RagnarBufferedReader {
    public static void main(String[] args) throws IOException {
        // Create stdin buffered reader
        BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
        String[] firstLine = br.readLine().split(" ");
        int n = Integer.parseInt(firstLine[0]);
        int q = Integer.parseInt(firstLine[1]);
        int m = Integer.parseInt(firstLine[2]);
        String[] secondLine = br.readLine().split(" ");
        String[] thirdLine = br.readLine().split(" ");
        int[] p = new int[n], t = new int[n];
        for (int i = 0; i < n; i++) {
            p[i] = Integer.parseInt(secondLine[i]);
            t[i] = Integer.parseInt(thirdLine[i]) + 1;
        }
        int[][] hop = new int[18][n];
        int r = 0;
        for (int i = 0; i < n; i++) {
            while (r < n - 1 && p[r + 1] <= p[i] + m) {
                r++;
            }
            hop[0][i] = r;
        }
        for (int l = 1; l < 18; l++) {
            for (int i = 0; i < n; i++) {
                hop[l][i] = hop[l - 1][hop[l - 1][i]];
            }
        }
        int inf = 2 * 1000000000;
        int[] jumpleft = new int[n];
        int best = t[0];
        for (int i = 0; i < n; i++) {
            jumpleft[i] = Math.min(t[i], best + 1);
            best = Math.min(t[i], best);
        }
        int[] jumpright = new int[n];
        jumpright[n - 1] = t[n - 1];
        best = n - 1;
        for (int i = n - 2; i >= 0; i--) {
            int h = numHops(i, best, hop, inf);
            if (h == inf) {
                best = i;
                jumpright[i] = t[i];
                continue;
            }
            int viabest = numHops(i, best, hop, inf) + jumpright[best];
            if (t[i] < viabest) {
                jumpright[i] = t[i];
                best = i;
            } else {
                jumpright[i] = viabest;
            }
        }
        // Create a buffered reader to read query lines
        for (int i = 0; i < q; i++) {
            String[] line = br.readLine().split(" ");
            int x = Integer.parseInt(line[0]) - 1;
            int y = Integer.parseInt(line[1]) - 1;
            if (x < y) {
                System.out.println(1);
                continue;
            }
            System.out.println(Math.min(numHops(x, y, hop, inf), Math.min(jumpleft[y], jumpright[y])));
        }
    }

    private static int numHops(int i, int j, int[][] hop, int inf) {
        int h;
        if (i > j) {
            int temp = i;
            i = j;
            j = temp;
        }
        if (hop[17][i] < j) {
            return inf;
        }
        h = 0;
        for (int l = 17; l >= 0; l--) {
            if (hop[l][i] < j) {
                h += 1 << l;
                i = hop[l][i];
            }
        }
        assert i < j;
        i = hop[0][i];
        h++;
        assert i >= j;
        return h;
    }
}
