#!/usr/bin/env python3

from math import isclose


# Note that the distance cannot be calculated with 64-bit floats, because 10^18 does not fit in 53 bits of precision
def dist(p1, p2): return (p2[0] - p1[0]) ** 2 + (p2[1] - p1[1]) ** 2


def is_parallel(p1, p2, p3, p4):
    return p1[1] == p2[1] and p3[1] == p4[1] or p1[1] != p2[1] and p3[1] != p4[1] and isclose(
        (p1[0] - p2[0]) / (p1[1] - p2[1]), (p4[0] - p3[0]) / (p4[1] - p3[1]), rel_tol=1e-10)


points = [tuple(map(int, input().split())) for _ in range(4)]
sides = [dist(p1, p2) for p1, p2 in zip(points, points[1:] + points[:1])]
equal_diagonals = dist(points[0], points[2]) == dist(points[1], points[3])
if all(s == sides[0] for s in sides):
    exit(print("square" if equal_diagonals else "rhombus"))
if sides[0] == sides[2] and sides[1] == sides[3]:
    exit(print("rectangle" if equal_diagonals else "parallelogram"))
if (sides[0] == sides[1] and sides[2] == sides[3] or sides[1] == sides[2] and sides[3] == sides[0]):
    exit(print("kite"))
print("trapezium" if is_parallel(*points) or is_parallel(*(points[1:] + points[:1])) else "none")
