#!/usr/bin/env python3
# DFS from unvisted vertices, marking everything below as non-root.
# Stop once reaching an already twice visited vertex.
# (Visiting the 2nd time is needed to find possible currently-marked-as-root
# vertices that need to be unmarked.)
import sys

sys.setrecursionlimit(int(1.1e5))

# Count the number of root SCCs
n, m = map(int, input().split())
g = [[] for _ in range(n)]
for _ in range(m):
    a, b = map(lambda x: int(x) - 1, input().split())
    g[a].append(b)


root = [True] * n
vs = [0] * n
cnt = [0] * n


def dfs(u, r):
    global vs
    stack = [u]
    while len(stack) > 0:
        u = stack.pop()
        for v in g[u]:
            if vs[v] == r or cnt[v] == 2:
                continue
            vs[v] = r
            root[v] = False
            cnt[v] += 1
            stack.append(v)


for u in range(n):
    if vs[u] == 0:
        r = u + 1
        vs[u] = r
        cnt[u] += 1
        dfs(u, r)

print(sum(root))
