#include <cmath>
#include <iomanip>
#include <iostream>
#include <numeric>
#include <queue>
#include <vector>
using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<ll, ll> ii;
typedef vector<ll> vi;
typedef vector<vi> vvi;
typedef vector<ii> vii;

#define x first
#define y second
#define pb push_back
#define eb emplace_back
#define rep(i, a, b) for(auto i = (a); i < (b); ++i)
#define REP(i, n) rep(i, 0, n)
#define all(v) (v).begin(), (v).end()
#define rs resize
#define DBG(x) cerr << __LINE__ << ": " << #x << " = " << (x) << endl

const ld PI = acos(-1.0);
template <class T>
using min_queue = priority_queue<T, vector<T>, greater<T>>;
template <class T>
int sz(const T& x) {
	return (int)x.size(); // copy the ampersand(&)!
}

template <class T>
ostream& operator<<(ostream& os, vector<T>& v) {
	os << "\n[";
	for(T& x : v) os << x << ',';
	return os << "]\n";
}

struct pairhash {
  public:
	template <typename T1, typename T2>
	size_t operator()(const pair<T1, T2>& p) const {
		size_t lhs = hash<T1>()(p.x);
		size_t rhs = hash<T2>()(p.y);
		return lhs ^ (rhs + 0x9e3779b9 + (lhs << 6) + (lhs >> 2));
	}
};

const string C = "wrgb";

void run() {
	ll w, h;
	cin >> h >> w;
	vvi A(w, vi(h));
	for(ll y = 0; y < h; y++) {
		string s;
		cin >> s;
		for(ll x = 0; x < w; x++) {
			A[x][y] = 1 << (C.find(s[x]));
		}
	}
	ll g     = gcd(w, h);
	ll count = 0;
	for(ll x1 = 0; x1 < w; x1++) {
		for(ll x2 = 0; x2 < w; x2++) {
			vvi B(g, vi(1 << 4, 0));
			for(ll y = 0; y < h; y++) {
				ll v        = A[x1][y] | A[x2][y];
				B[y % g][v] = true;
			}
			for(ll y = 0; y < g; y++) {
				for(ll v = 0; v < (1 << 4); v++) {
					count += B[y][v] * B[((y + x2 - x1) % g + g) % g][(1 << 4) - 1 - v];
				}
			}
		}
	}
	// cerr << count << endl;
	if(count == 0)
		cout << "impossible" << endl;
	else
		cout << "possible" << endl;
}

signed main() {
	// DON'T MIX "scanf" and "cin"!
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout << fixed << setprecision(20);
	run();
	return 0;
}
