#!/usr/bin/python3

from math import gcd

height, width = [int(x) for x in input().split()]
g = gcd(height, width)
grid = [input() for _ in range(height)]

all_available = set()

for h in range(height):
    for w1 in range(width):
        for w2 in range(w1 + 1, width):
            if grid[h][w1] != grid[h][w2]:
                all_available.add((h % g, w1, w2, tuple(sorted([grid[h][w1], grid[h][w2]]))))

letters_map = {}
for h, w1, w2, letters in all_available:
    if letters not in letters_map:
        other_letters = tuple(sorted([x for x in "rwgb" if x not in letters]))
        letters_map[letters] = other_letters
    if ((h + w2 - w1) % g, w1, w2, letters_map[letters]) in all_available:
        print("possible")
        break
else:
    print("impossible")

