#!/usr/bin/env python3
# Do a DFS from random points, marking everything below as non-root.
# Skip already non-root vertices.
# TLEs because O(n) size subtrees can be traversed O(n) times.
import sys

sys.setrecursionlimit(int(2.1e5))

# Count the number of root SCCs
n, m = map(int, input().split())
g = [[] for _ in range(n)]
for _ in range(m):
    a, b = map(lambda x: int(x) - 1, input().split())
    g[a].append(b)


root = [True] * n
vs = [0] * n


def visit(u, r):
    global vs
    for v in g[u]:
        if vs[v] == r:
            continue
        vs[v] = r
        root[v] = False
        visit(v, r)


for u in range(n):
    if vs[u] == 0:
        r = u + 1
        vs[u] = r
        visit(u, r)

print(sum(root))
