import java.util.Scanner;

public class NickyEnMarkPrecisionErrors {
	private static double INF = 1e10;
	private static double EPSILON = 1e-9;

	public static void main(String[] args) {
		Scanner scanner = new Scanner(System.in);
		double x1 = scanner.nextDouble();
		double y1 = scanner.nextDouble();
		double x2 = scanner.nextDouble();
		double y2 = scanner.nextDouble();
		double x3 = scanner.nextDouble();
		double y3 = scanner.nextDouble();
		double x4 = scanner.nextDouble();
		double y4 = scanner.nextDouble();
		double rc1 = rc(x1, x2, y1, y2);
		double rc2 = rc(x2, x3, y2, y3);
		double rc3 = rc(x3, x4, y3, y4);
		double rc4 = rc(x4, x1, y4, y1);
		double dist1 = dist(x1, x2, y1, y2);
		double dist2 = dist(x2, x3, y2, y3);
		double dist3 = dist(x3, x4, y3, y4);
		double dist4 = dist(x4, x1, y4, y1);
		if (orthogonal(rc1, rc2) && orthogonal(rc2, rc3) && orthogonal(rc3, rc4) && orthogonal(rc4, rc1)) {
			if (dist1 == dist2 && dist2 == dist3 && dist3 == dist4) {
				System.out.println("square");
			} else {
				System.out.println("rectangle");
			}
		} else if (dist1 == dist2 && dist2 == dist3 && dist3 == dist4) {
			System.out.println("rhombus");
		} else if (rc1 == rc3 && rc2 == rc4) {
			System.out.println("parallelogram");
		} else if (rc1 == rc3 || rc2 == rc4) {
			System.out.println("trapezium");
		} else if ((dist1 == dist2 && dist3 == dist4) || (dist2 == dist3 && dist1 == dist4)) {
			System.out.println("kite");
		} else {
			System.out.println("none");
		}
	}

	private static boolean orthogonal(double rc1, double rc2) {
		if (rc1 == 0 && rc2 == INF) {
			return true;
		} else if (rc1 == INF && rc2 == 0) {
			return true;
		} else {
			return Math.abs(rc1 * rc2 + 1) < EPSILON;
		}
	}

	private static double rc(double x1, double x2, double y1, double y2) {
		if (x1 == x2) {
			return INF;
		}

		return (y2 - y1) / (x2 - x1);
	}

	private static double dist(double x1, double x2, double y1, double y2) {
		return Math.sqrt((x2 - x1) * (x2 - x1) + (y2 - y1) * (y2 - y1));
	}
}
