#!/usr/bin/env python3

from math import atan2, dist, isclose


def is_parallel(p1, p2, p3, p4):
    return isclose(atan2(p1[1] - p2[1], p1[0] - p2[0]), atan2(p4[1] - p3[1], p4[0] - p3[0]), rel_tol=1e-12)


points = [tuple(map(int, input().split())) for _ in range(4)]
sides = [dist(p1, p2) for p1, p2 in zip(points, points[1:] + points[:1])]
equal_diagonals = isclose(dist(points[0], points[2]), dist(points[1], points[3]), rel_tol=1e-10)
if all(s == sides[0] for s in sides):
    exit(print("square" if equal_diagonals else "rhombus"))
if sides[0] == sides[2] and sides[1] == sides[3]:
    exit(print("rectangle" if equal_diagonals else "parallelogram"))
if (isclose(sides[0], sides[1]) and isclose(sides[2], sides[3]) or
        isclose(sides[1], sides[2]) and isclose(sides[3], sides[0])):
    exit(print("kite"))
print("trapezium" if is_parallel(*points) or is_parallel(*(points[1:] + points[:1])) else "none")
